#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<ll> graph[200000];
bool used[200000];
ll dist[200000];


bool cmp(ll a1, ll a2){
    return a1>a2;
}


void dfs(ll node, ll p){
    used[node]=1;
    if (p==-1) dist[node]=0;
    else dist[node]=dist[p]+1; //cout << dist[node] << " ";

    for (auto to: graph[node]){
        if (!used[to]) dfs(to, node);
    }
}




int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, k, t, i, j; cin >> n >> k >> t;

    for (i=0;  i<n-1; i++){
        ll q, v; cin >> q >> v; v--; q--;
        graph[q].push_back(v); graph[v].push_back(q);
    }

    if (t==0){
        for (j=0; j<n; j++) {dist[j]=0; used[j]=0;}
        dfs(0, -1);

        //for (j=0; j<n; j++) cout << dist[j] << " "; cout << endl;
        sort(dist, dist+n, cmp);
        if (k==n-1) cout << 1;
        else cout << dist[k] << " ";

    }
    else{
        for (i=0; i<n; i++){
            for (j=0; j<n; j++) {dist[j]=0; used[j]=0;}
            dfs(i, -1);
            //for (j=0; j<n; j++) cout << dist[j] << " "; cout << endl;
            sort(dist, dist+n, cmp);

            if (k==n-1) cout << 1;
            else cout << dist[k] << " ";
        }
    }



    return 0;
}